<?php

namespace Drupal\config_policy\Rule;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\DependentPluginInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\config_policy\Policy\ConfigPolicyRepositoryInterface;
use Drupal\Core\Entity\EntityTypeBundleInfoInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Psr\Log\LoggerInterface;

interface ConfigRuleInterface extends PluginInspectionInterface, ConfigurableInterface, DependentPluginInterface, PluginFormInterface {

  public function __construct(array $configuration, $plugin_id, $plugin_definition, LoggerInterface $logger, EntityTypeManagerInterface $entity_type_manager, EntityTypeBundleInfoInterface $entity_type_bundle, ConfigPolicyRepositoryInterface $config_policy_repository);

  public function getSummary(): array;

  public function getUuid(): string;

  public function getWeight(): string;

  public function setWeight($weight): void;

  public function getLabel(): string;

  public function getDescription(): string;

  public function getConfigPatterns(): array;

  public function getPreventableForms(): array;

  public function getSettings(): array;

  public function ajaxCallback(array &$form, FormStateInterface $form_state): void;

}
